/* Programa: Music.prg
   Creditos: IBM, programa original en GWBASIC, 1981
	     Dennis L. Dias, funcion TONE() en ensamblador 09/12/87
   Autor:    Juan Carlos Ocampo de la Cruz, Version en Clipper 04/11/93
             e-mail: SodaStereano@hotmail.com
             Acapulco, Mxico */

* ---------------- Programa: sample.PRG -----------------------------------*
* ---------------- Autor:    Mustafa Lpez --------------------------------*
* ---------------- Generado con WinPrg 3.04   20/01/2010 14:09:13 --------*

#include'minigui.ch'
Function Main()
SET PROCEDURE TO ABOUT

      REQUEST HB_Lang_ES
      REQUEST HB_CODEPAGE_ESWIN
      HB_LangSelect('ES')
      HB_SetCodePage('ESWIN')

SET DATE FRENCH
SET CENTURY ON
SET ESCAPE ON
SET LANGUAGE TO SPANISH

               DEFINE WINDOW Win_1 ;
                      AT 0,0 ;
                      WIDTH 800 ;
                      HEIGHT 600 ;
                      TITLE 'Music Tone v.02' ;
                      MAIN NOMAXIMIZE
                      ON KEY ESCAPE ACTION Win_1.Release

                   DEFINE MAIN MENU
                        POPUP '&Music_A'
                               ITEM 'Yankee_Doodle'       ACTION Yankee_Doodle()    
                               ITEM 'La Cucaracha'        ACTION La_Cucaracha()
                               ITEM 'Blue Danube Waltz'   ACTION Blue_Danube_Waltz() 
                               ITEM 'Humoresque'          ACTION Humoresque()        
                               ITEM 'Pop Goes The Weasel' ACTION Pop_Goes_The_Weasel()  
                               ITEM 'Symphony_40'         ACTION Symphony_40()      
                               SEPARATOR
                               ITEM 'Exit'  ACTION thiswindow.release
                        END POPUP
                        POPUP '&Music_B'
                               ITEM 'Funeral March'       ACTION Funeral_March()   
                               ITEM 'Stars_And_Stripes'   ACTION Stars_And_Stripes()  
                               ITEM 'El_sombrero'         ACTION El_sombrero()   
                               ITEM 'Sakura'              ACTION Sakura()    
                               ITEM 'Escalas'             ACTION Escalas()  
                               SEPARATOR
                               ITEM 'About' ACTION ABOUT()  
                        END POPUP
                   END MENU


               END WINDOW
                      CENTER WINDOW Win_1

                      ACTIVATE WINDOW Win_1
RETURN NIL



PROCEDURE Sonido(aFrecDurac)

  FOR nIndice=1 TO LEN(aFrecDurac) STEP 2        
     *** Quien sabe que significa esta formula, pero funciona
     TONE(36.8*(2^(1/12))^(aFrecDurac[nIndice]-6),aFrecDurac[nIndice+1])
  NEXT
RETURN

*------------------------------*
PROCEDURE Yankee_Doodle()   
*------------------------------* 

        aNotas1={50,3,50,3,52,3,54,3,50,3,54,3,52,3,45,3,50,3,50,3,52,3,54,3,50,6,;
	       49,3,1,3,;
	       50,3,50,3,52,3,54,3,55,3,54,3,52,3,50,3,49,3,45,3,47,3,49,3,50,6,;
	       50,3,1,3,;
	       47,5,49,1,47,3,45,3,47,3,49,3,50,3,1,3,45,5,47,1,45,3,43,3,42,6,;
	       45,3,1,3,;
	       47,5,49,1,47,3,45,3,47,3,49,3,50,3,47,3,45,3,50,3,49,3,52,3,50,6,;
	       50,6}


  Sonido(aNotas1)      

RETURN

*------------------------------*
PROCEDURE La_Cucaracha()  
*------------------------------*        

       aNotas2={42,1,1,1,42,1,1,1,42,1,1,1,47,1,1,5,51,1,1,3,42,1,1,1,42,1,1,1,;
	       42,1,1,1,47,1,1,5,51,1,1,5,30,1,1,1,30,1,1,1,35,1,1,3,47,1,1,1,;
	       47,1,1,1,46,1,1,1,46,1,1,1,44,1,1,1,44,1,1,1,42,8,1,2,42,1,1,1,;
	       42,1,1,1,42,1,1,1,46,1,1,5,49,1,1,3,42,1,1,1,42,1,1,1,42,1,1,1,;
	       46,1,1,5,49,1,1,5,37,1,1,1,37,1,1,1,30,1,1,3,54,2,56,2,54,2,52,2,;
	       51,2,49,2,47,8}

  Sonido(aNotas2)     
RETURN

*------------------------------*
PROCEDURE Blue_Danube_Waltz() 
*------------------------------*     
   nOpcion=3
       aNotas3={42,4,46,4,49,4,49,4,1,4,61,2,1,2,61,2,1,6,58,2,1,2,58,2,1,6,42,4,42,4,;
	       46,4,49,4,;
	       49,4,1,4,61,2,1,2,61,2,1,6,59,2,1,2,59,2,1,6,41,4,41,4,44,4,51,4,51,4,;
	       1,4,63,2,1,2,63,2,1,6,59,2,1,2,;
	       59,2,1,6,41,4,41,4,44,4,51,4,51,4,1,4,63,2,1,2,63,2,1,6,58,2,1,2,58,2,;
	       1,6,42,4,;
	       42,4,46,4,49,4,54,4,1,4,66,2,1,2,66,2,1,6,61,2,1,2,61,2,1,6,42,4,;
	       42,4,46,4,49,4,54,4,1,4,66,2,1,2}
       *** Para evitar el error PARSE STACK OVERFLOW
       aNotas4={66,2,1,6,63,2,1,2,63,2,1,6,44,4,44,4,47,4,51,2,1,2,51,14,1,2,48,4,;
		49,4,58,16,;
		54,4,46,4,46,8,44,4,51,8,49,4,42,4,1,2,42,2,42,4,1,8,49,2,1,2,47,2,;
		1,6,49,2,1,2,;
		47,2,1,6,49,4,58,16,56,4,49,2,1,2,46,2,1,6,49,2,1,2,46,2,1,6,49,4,;
		56,16,54,4,49,2,1,2,47,2,1,6,49,2,1,2,47,2,1,6,49,4,58,16,;
		56,4,49,4,54,4,56,4,58,4,61,8,59,4,58,2,58,2,58,4,58,2,1,2,54,4,1,8}
  Sonido(aNotas3)      
  IF nOpcion=3 .AND. LASTKEY()#27
     Sonido(aNotas4) // Si es la melodia mas larga, toca la 2da. parte
  ENDIF

 RETURN

*-------------------------------*
PROCEDURE Humoresque()      
*-------------------------------*    

       aNotas5={47,3,1,2,49,1,47,3,1,2,49,1,51,3,1,2,54,1,56,3,1,2,54,1,;
	       59,3,1,2,58,1,61,3,1,2,59,1,58,3,1,2,61,1,59,3,1,2,56,1,;
	       54,3,1,2,54,1,56,3,1,2,54,1,59,3,1,2,56,1,54,3,1,2,51,1,;
	       49,24,47,3,1,2,49,1,47,3,1,2,49,1,51,3,1,2,54,1,56,3,1,2,54,1,;
	       56,3,1,2,58,1,61,3,1,2,59,1,58,3,1,2,61,1,59,3,1,2,56,1,;
	       54,3,1,2,54,1,59,3,1,2,47,1,49,6,54,6,47,18}


  Sonido(aNotas5)      
RETURN

*-------------------------------*
PROCEDURE Pop_Goes_The_Weasel()   
*-------------------------------*    

       aNotas6={47,2,1,2,47,2,49,2,1,2,49,2,51,2,54,2,51,2,47,2,1,2,42,2,;
	       47,2,1,2,47,2,49,2,1,2,49,2,51,6,47,2,1,2,42,2,47,2,1,2,47,2,49,2,;
	       1,2,49,2,51,2,54,2,51,2,47,2,1,4,56,2,1,4,49,2,1,2,52,2,51,6,47,2,;
	       1,4,59,2,1,2,59,2,56,2,1,2,59,2,58,2,61,2,58,2,54,2,1,4,59,2,1,2,;
	       59,2,56,2,1,2,59,2,58,6,54,2,1,2,51,2,52,2,1,2,51,2,52,2,1,2,54,2,;
	       56,2,1,2,58,2,59,2,1,4,56,2,1,4,49,2,1,2,52,2,51,6,47,2}

  Sonido(aNotas6)     
RETURN
*------------------------------*
PROCEDURE Symphony_40()    
*------------------------------*    
 
      aNotas7={55,2,54,2,54,4,55,2,54,2,54,4,55,2,54,2,54,4,62,4,1,4,;
	      62,2,61,2,59,4,59,2,57,2,55,4,55,2,54,2,;
	      52,4,52,4,1,4,54,2,52,2,52,4,54,2,52,2,52,4,54,2,52,2,;
	      52,4,61,4,1,4,61,2,59,2,58,4,58,2,55,2,54,4,54,2,52,2,;
	      50,4,50,4,1,4,62,2,61,2,61,4,64,4,58,4,61,4,;
	      59,4,54,4,1,4,62,2,61,2,61,4,64,4,58,4,61,4,;
	      59,4,62,4,61,2,59,2,57,2,55,2,54,4,46,4,47,4,49,4,;
	      50,4,52,2,50,2,49,4,47,4,54,4,1,4,65,8,;
	      66,2,1,6,65,8,66,2,1,6,65,8,;
	      66,4,65,4,66,4,65,4,66,4}

  Sonido(aNotas7)     
RETURN

*------------------------------*
PROCEDURE Funeral_March()           //  Funeral March of a Marionette
*------------------------------*   
 
      aNotas8={37,1,1,2,30,1,1,5,42,3,42,3,41,3,39,3,41,3,1,3,42,3,44,3,1,3,37,1,1,2,;
	      30,1,1,5,42,3,42,3,41,3,39,3,41,3,1,3,42,3,44,3,1,3,37,3,42,3,1,3,45,3,;
	      49,6,47,3,45,3,1,3,49,3,52,6,50,3,49,3,1,3,53,3,56,6,54,3,53,3,50,3,;
	      49,3,47,3,45,3,44,3,30,1,1,5,42,3,42,3,41,3,39,3,41,3,1,3,42,3,44,3,;
	      1,3,37,1,1,2,30,1,1,5,42,3,42,3,41,3,39,3,41,3,1,3,42,3,44,3,1,3,;
	      37,3,45,3,1,3,49,3,52,6,50,3,49,3,47,3,45,3,43,3,47,3,50,3,42,3,;
	      41,3,42,3,44,3,1,3,45,1,1,2,44,9,42,1}


  Sonido(aNotas8)     
RETURN

*------------------------------*
PROCEDURE Stars_And_Stripes()      //   Stars And Stripes Forever
*------------------------------*    

      aNotas9={54,6,54,6,52,3,51,3,51,6,50,3,51,3,51,16,1,2,50,3,;
	      51,3,51,6,50,3,51,3,;
	      54,6,51,3,54,3,52,12,49,6,1,3,49,3,49,6,48,3,49,3,;
	      49,6,48,3,49,3,;
	      52,16,1,2,51,3,49,3,51,3,54,9,56,9,56,3,49,16,1,2,54,6,;
	      54,6,52,3,51,3,51,6,50,3,51,3,51,16,1,2,50,3,51,3,51,6,50,3,51,3,;
	      52,3,51,3,49,5,46,1,49,12,47,6,1,3,47,3,47,6,46,3,47,3,50,6,49,3,47,3,;
	      59,15,1,3,47,3,49,3,51,3,54,1,1,2,47,3,49,3,51,3,54,1,1,2,42,3,44,5,;
	      51,1,49,12,47,1}


  Sonido(aNotas9)     
RETURN

*------------------------------*
PROCEDURE El_sombrero()    
*------------------------------*    
 
      aNotas10={52,2,57,2,1,2,52,2,57,2,1,2,52,2,57,6,1,4,52,2,57,2,59,2,57,2,56,4,;
	      57,2,59,2,1,8,52,2,56,2,1,2,52,2,56,2,1,2,52,2,56,6,1,4,52,2,;
	      56,2,57,2,56,2,54,4,56,2,57,2,1,6,64,2,63,2,64,2,61,2,60,2,61,2,;
	      57,2,56,2,57,2,52,2,1,4,49,2,50,2,52,2,54,2,56,2,57,2,59,2,61,2,;
	      62,2,59,2,1,4,62,2,61,2,62,2,59,2,58,2,59,2,56,2,55,2,56,2,52,2,;
	      1,4,64,2,63,2,64,2,66,2,64,2,62,2,61,2,59,2,57,2}


  Sonido(aNotas10)     
RETURN

*------------------------------*
PROCEDURE Sakura()    
*------------------------------*    
        aNotas11={49,8,49,8,51,12,1,4,49,8,49,8,51,12,1,4,49,8,51,8,52,8,51,8,;
	       49,8,51,4,49,4,45,16,44,8,40,8,44,8,45,8,;
	       44,8,44,4,40,4,39,16,49,8,49,8,51,12,1,4,49,8,49,8,51,12,1,4,;
	       40,8,44,8,45,8,49,8,51,4,49,4,45,8,44,16}

  Sonido(aNotas11)     
RETURN

*------------------------------*
PROCEDURE Escalas()    
*------------------------------*    
   
      aNotas12={38,1,39,1,40,1,41,1,42,1,43,1,44,1,45,1,46,1,47,1,;
	      48,1,49,1,50,1,51,1,52,1,53,1,54,1,55,1,56,1,;
	      57,1,58,1,59,1,60,1,61,1,62,1,63,1,64,1,65,8,1,4,;
	      65,8,64,1,63,1,62,1,61,1,60,1,59,1,58,1,57,1,;
	      56,1,55,1,54,1,53,1,52,1,51,1,50,1,49,1,48,1,;
	      47,1,46,1,45,1,44,1,43,1,42,1,41,1,40,1,39,1,38,8}

  Sonido(aNotas12)     
RETURN


























































































































































































































































